/**
 * @file DrvrAccess.c
 *
 * @brief Driver Access Library (aka DAL).
 *
 * @author Copyright (C) 2004 - 2009 CERN. Yury GEORGIEVSKIY <ygeorgie@cern.ch>
 *
 * @date Created on 27/04/2004
 *
 * This library is automatically generated by the @b DriverGen utility and
 * should be used to access the driver, which also was generated by the
 * @b DriverGen. To be able to use this lib, driver should be installed by the
 * @b modinst utility, which also was generated by the @b DriverGen tool.
 *
 * @section license_sec License
 *          Released under the GPL
 */
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdint.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <drvrutil/ioconfiglib.h>
#include "ServiceRegIoctl.h"	/* for service registers access */
#include "ServiceRegId.h"	/* for service registers access */
#include "dal.h"
#include "lklist.h"		/* Linux Kernel Source's list.h */

static char *g_dalvers = "2.0";	/* current library version
				 *SHOULD* be changed everytime library does!
				 Last modificatioin date: 02.12.2009 */

/* generation date */
static char *g_daltime __attribute__ ((unused)) = "<dg_comment>";


/* DA Library generation date ( <dg_comment> ) */
#define DAL_GENERATION_TIME <hex_num>

/* handle assertion */
#define ASSERT_USR_H(_h)					\
({								\
  da_err_t _val = 0; /* no error */				\
  if (!_h)							\
    _val = -DA_ERR_BAD_HANDLE; /* user handle in bad */		\
  else if (_h == (_dal_h*)-DA_ERR_NOT_INIT)			\
    _val = -DA_ERR_NOT_INIT;	/* library was not init */	\
 _val;								\
})

/* get reg descr from the hash table */
#define GET_REG_DESC(_h, _r)				\
({							\
  REGDESC *_val = NULL;					\
  if (WITHIN_RANGE(0, _r, _h->dit.regAmount - 1))	\
    _val = _h->reg_hash_tbl[_r];			\
  _val;							\
})

/* external crap */
extern int snprintf(char *str, size_t size, const char *format, ...);
extern int MMRegAccess(_dal_h *, REGDESC *, REGOPTYPE, int, int, char*, char*);
extern int init_dma(_dal_h *);
extern int do_dma(_dal_h *, REGDESC *, REGOPTYPE, int, int, void *, int);

/*======================Global data==========================================*/
LIST_HEAD(glob_dal_h_list);	/* linked list of user handles */

/* library error decoding */
da_err_str_t dal_err_human[DA_ERR_LAST + 1] = {
	{			/* 0 */
	 .da_err_code = "DA_ERR_ALL_OK",
	 .da_err_str  = "we cool"
	},
	{			/* 1 */
	 .da_err_code = "DA_ERR_BAD_HANDLE",
	 .da_err_str  = "library handle is bad"
	},
	{			/* 2 */
	 .da_err_code = "DA_ERR_NO_REG",
	 .da_err_str  = "no such register"
	},
	{			/* 3 */
	 .da_err_code = "DA_ERR_INT_ERR",
	 .da_err_str  = "internal error. info is printed out on stderr if"
	 " DA_DBG_ERR_INFO debug flag is set"
	},
	{			/* 4 */
	 .da_err_code = "DA_ERR_REG_BOUNDS",
	 .da_err_str  = "required elements are beyond register bounds"
	},
	{			/* 5 */
	 .da_err_code = "DA_ERR_IOCTL_FAIL",
	 .da_err_str  = "ioctl call fails"
	},
	{			/* 6 */
	 .da_err_code = "DA_ERR_BAD_AM",
	 .da_err_str  = "bad register access method"
	},
	{			/* 7 */
	 .da_err_code = "DA_ERR_NOT_INIT",
	 .da_err_str  = "library was _NOT_ initialized"
	},
	{			/* 8 */
	 .da_err_code = "DA_ERR_B2S",
	 .da_err_str  = "provided buffer is too small"
	},
	{			/* 9 */
	 .da_err_code = "DA_ERR_NOT_ALLOW",
	 .da_err_str  = "requested operation not allowed"
	},
	{			/* 10 */
	 .da_err_code = "DA_ERR_INCOMPAT",
	 .da_err_str  = "DAL <-> driver incompatible. Driver should be"
	 " re-generated by the driverGen"
	},
	{			/* 11 */
	 .da_err_code = "DA_ERR_ERR",
	 .da_err_str  = "General DAL error. See function manual for more"
	 " details"
	},
	{			/* 12 */
	 .da_err_code = "DA_BAD_PARAM",
	 .da_err_str  = "provided parameters are bad. See function manual for"
	 " more details"
	},
	{			/* 13 */
	 .da_err_code = "DA_SYS_FAIL",
	 .da_err_str  = "system call failed"
	},
	{			/* 14 */
	 .da_err_code = "UNKNOWN ERROR",
	 .da_err_str  = "Unknown DAL Error"
	}
};
/*==================END of global data=======================================*/
static da_err_t map_device(int, DevInfo_t *, int, char **, char **);
static char *LIBBuildUpName(char *, int, int);
static _dal_h *dalAddHandle(void);
static int dalDoRegHashTbl(_dal_h *);
static inline int dalGetIoctlId(int, int *, int *);
static inline _dal_h *dalGetHandle(HANDLE);
static char *LIBMatchEndian(char *, int, int);
static void __attribute__ ((unused)) LIBPrintoutDevInfoT(DevInfo_t *);

/**
 * @brief Major function that enables user to work with the driver of
 *        module @e modName, if it is installed in the system.
 *
 * @param modName -- Module Name (exactly as in the DataBase)
 * @param regAm   -- registers access method @b IOCLT, @b IOMMAP, @b IODMA
 *                   and @b IOLAST
 * @param lun     -- Logical Unit Number assigned to the module
 *                   Negative in case of driver simulator
 * @param chanN   -- Minor Device Number. There can be several entry points
 *                   for current Logical Unit Number (Channel Number).
 *
 * There are several possible methods to access hardware module registers. These
 * are @b IOCLT, @b IOMMAP and @b IODMA (Linux only). All of them can be set.
 * 1. If @e am is @b IOCLT - then module registers will be access through
 * standard @e ioctl system call.
 *
 * 2. In case of @b IOMMAP access method, module register access  will be done
 * through the mapped memory of the hardware module, which will
 * be mapped on the kernel memory space.
 * This mechanism is much more faster and therefore more efficient, but not
 * always available and rather dangerous.
 * In case of Lynx -- Additional libraries should be linked (namely
 * @e libdrvrutil library) to be able to use this method.
 * If user will work with Simulator - it is not possible to access registers
 * through mapped memory (because there is no actual device present in this
 * case).
 * Service Registers are virtual registers, and always accessed through
 * standard @e ioctl calls (i.e. only IOCTL)
 * Their access mode will be automatically set to @b IOCTL in spite of @e am
 * parameter value.
 *
 * 3. IODMA is valid for Linux only.
 *    Direct Memory Access will be used to access the HW (through TSI148 chip)
 *    User should be reasanable while choosing if to use it or not, as the
 *    drawbacks can outcome the advantages.
 *    It's worth to use it only if you intended to r/w big chunks of data
 *    (bigger then one page at least).
 *    Still you can you use it with any amount of data, but it will be
 *    much more faster to read several memory locations/HW registers,
 *    using IOCTL or IOMMAP access methods.
 *
 * @note Driver/Simulator <b>MUST be newer</b>, i.e. generated by the
 *       @e driverGen @b after @e DAL was generated! Normally function should
 *       return an error (-DA_ERR_INCOMPAT) if it's not the case. But for now
 *       (as of 16.01.2008) it just warn the user.
 *
 * @return Library Handle is returned if SUCCEESS. (some positive value)
 *
 * In case of failure one of the following:
 * @return -DA_ERR_BAD_HANDLE - Module name 'modName' is NOT provided.
 *                              Driver for module 'modName' possibly is
 *                              NOT install in the system.
 * @return -DA_ERR_INT_ERR    - Internal library error occurs.
 *                              Printout error info in stderr.
 * @return -DA_ERR_BAD_AM     - desired register access method is not
 *                              allowed
 * @return -DA_ERR_IOCTL_FAIL - ioctl call fails
 * @return -DA_ERR_INCOMPAT   - @b TODO! consistency checking failed.
 *                              Driver appears to be older than DAL
 *                              (i.e. was generated by the driverGen @b BEFORE
 *                              the DAL). Driver <b>MUST be re-generated!</b>
 * @return -DA_SYS_FAIL       - can't mmap device memory (Linux only)
 */
HANDLE DaEnableAccess(char *modName, METHOD regAm, int lun, int chanN)
{
	int drFd;		/* driver file descriptor */
	_dal_h *dhptr;		/* handle pointer */
	int ret;		/* return code */
	DevInfo_t dit;	/* Device info table (comming from the driver) */
	char *map1 = (char *) MAP_FAILED; /* 1'st mapped address */
	char *map2 = (char *) MAP_FAILED; /* 2'nd mapped address */
	char *dfn;		/* driver/simulator node name */
	time_t drvr_generation_date = 0; /* when driver was generated by
					    the driverGen */
	unsigned long arguments[3];	/* ioctl arguments */

	if (!modName || !(*modName) || (*modName == '0')) {
		/* uuuuuu maaaan... you are doing something weird! RTFM! */
		fprintf(stderr,	"DAL: %s:Module name is NOT provided!"
			" Aborting...\n", ERR_MSG);
		return (HANDLE) -DA_ERR_BAD_HANDLE;
	}

	if ((regAm & IOMMAP) && (lun < 0)) {
		/* this is simulator. Only IOCTL access method is allowed */
		fprintf(stderr, "DAL: %sThis is simulator. ONLY ioctl access"
			" method is allowed in this case! Aborting...\n",
			ERR_MSG);
		return (HANDLE)-DA_ERR_BAD_AM;
	}

	/* open driver file */
	dfn = LIBBuildUpName(modName, lun, chanN);
	if ((drFd = open(dfn, O_RDWR)) == -1) {
		fprintf(stderr, "DAL: %sCan't open %s device node. Check if"
			" %s is installed as well as validity of provided"
			" LUN (-U option) and Channel Number (-C option)."
			" Aborting...\n",
			ERR_MSG, dfn, (lun < 0) ? "Simulator" : "Driver");
		return (HANDLE) -DA_ERR_BAD_HANDLE;
	}

	/* DAL <-> simulator/driver consistency checking */
	if (ioctl(drFd, SRV_GET_DAL_CONSISTENT, &drvr_generation_date)) {
		fprintf(stderr, "DAL: %slibrary <-> %s driver consistensy"
			" checking failure for module %s.\n",
			WARNING_MSG, (lun < 0) ? "simulator" : "real", modName);
		return -DA_ERR_IOCTL_FAIL;
	} else if (drvr_generation_date < DAL_GENERATION_TIME) {
		/* error msg to the user */
		fprintf(stderr, "DAL: %sCurrent library version is newer"
			" then %s %s generaton date.\n", WARNING_MSG, modName,
			(lun < 0) ? "Simulator" : "Driver");
		fprintf(stderr, "DAL: %sLack of library productivity since"
			" %s %s doesn't incapsulate new features.\n",
			WARNING_MSG, modName,
			(lun < 0) ? "Simulator" : "Driver");
		fprintf(stderr, "DAL: %sYou %sMUST%s re-generate %s %s source"
			" code, using the lates 'driverGen' version to achieve"
			" full driver/library productivity.\n",
			WARNING_MSG, RED_CLR, END_CLR, modName,
			(lun < 0) ? "Simulator" : "Driver");
		sleep(5);
		/* normally we SHOULD return an error!
		   But for now - we just warn user */
		//close(drFd);
		//return -DA_ERR_INCOMPAT;
	}

	/* obtain device information */
	if (ioctl(drFd, SRV_GET_DEVINFO_T, &dit)) {
		fprintf(stderr, "DAL: %sCan't get %s Information Table.\n",
			ERR_MSG, (lun < 0) ? "Simulator" : "Driver");
		close(drFd);
		return (HANDLE) -DA_ERR_IOCTL_FAIL;
	}

	if (regAm & IOMMAP) {
		/* map hw */
		ret = map_device(drFd, &dit, lun, &map1, &map2);
		if (ret) {
			close(drFd);
			return (HANDLE) ret;
		}
	}

	/* add new user handle and set it's ID */
	if ((dhptr = dalAddHandle()) == NULL) {
		fprintf(stderr, "DAL: %sCan't add user handle.\n", ERR_MSG);
		close(drFd);
		return (HANDLE) -DA_ERR_INT_ERR;
	}

	/* now init handle data */
	dhptr->dal_flag = (regAm & IOLAST) ? DA_DBG_ALL : 0;
	regAm &= ~IOLAST;	/* get rid of this bit */
	dhptr->drvrFd = drFd;
	dhptr->lun = lun;
	dhptr->reqAm = regAm;

	/* in case if user requests several Access Modes
	   (regAm is not pow2) -- set IOCTL one as default,
	   otherwise set requested mode */
	dhptr->defAm = (regAm & (regAm-1)) ? IOCTL : regAm;

	dhptr->ma1 = map1;
	dhptr->ma2 = map2;
	dhptr->dit = dit;
	dhptr->uh_vers_info_str = NULL;
	dhptr->uh_dgd = drvr_generation_date;

	/* init DMA */
	if (regAm & IODMA) {
		if (init_dma(dhptr)) {
			fprintf(stderr, "DAL: %sCan't init DMA access.\n",
				ERR_MSG);
			free(dhptr);
			close(drFd);
			return (HANDLE) -DA_ERR_INT_ERR;
		}
	}

	/* create register hash table */
	if (dalDoRegHashTbl(dhptr)) {
		fprintf(stderr, "DAL: %sCan't allocate register hash table.\n",
			ERR_MSG);
		/* close DMA handle */
		if (dhptr->dma.fd) close(dhptr->dma.fd);
		free(dhptr);
		close(drFd);
		return (HANDLE) -DA_ERR_INT_ERR;
	}

	/* now set driver version and driver version info string */
	dhptr->uh_vers_info_str =
		calloc((GET_REG_DESC(dhptr, __SRV__DRVR_VERS_ID))->regSize,
		       sizeof(char));	/* allocate space for the version
					   info string */

	if (!dhptr->uh_vers_info_str) {	/* we fucked */
		fprintf(stderr,
			"DAL: %sCan't allocate version information string.\n",
			ERR_MSG);
		/* exclude from the list */
		list_del(&dhptr->hndl_list);

		/* close DMA handle */
		if (dhptr->dma.fd) close(dhptr->dma.fd);

		/* cleanup allocated memory */
		free(dhptr->reg_hash_tbl);
		free(dhptr);

		close(drFd);
		return (HANDLE) -DA_ERR_INT_ERR;
	}

	/* pack ioctl arguments */
	/* driver version (integer) */
	arguments[0] = (unsigned long) &dhptr->uh_drvr_vers;
	/* driver info version string */
	arguments[1] = (unsigned long) dhptr->uh_vers_info_str;
	arguments[2] = 0; /* not used, but param amount should be 3 */

	/* get version string */
	if (ioctl(dhptr->drvrFd, SRV_GET_DRVR_VERS, (char *)arguments)) {
		/* hmmmm..... it seems that we are fucked */
		fprintf(stderr, "DAL: %sCan't get %s Version information."
			" SRV_GET_DRVR_VERS ioctl fail.\n",
			ERR_MSG, (lun < 0) ? "Simulator" : "Driver");
		/* exclude from the list */
		list_del(&dhptr->hndl_list);

		/* close DMA handle */
		if (dhptr->dma.fd) close(dhptr->dma.fd);

		/* cleanup allocated memory */
		free(dhptr->reg_hash_tbl);
		free(dhptr->uh_vers_info_str);
		free(dhptr);
		close(drFd);
		return -DA_ERR_IOCTL_FAIL;
	}

	if (dhptr->dal_flag)	/* debug printing */
		LIBPrintoutDevInfoT(&(dhptr->dit));

	return dhptr->hID;
}

/**
 * @brief Should be called when user finish his work with module driver.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 *
 * Cleans up everything that is needed.
 *
 * @return  DA_ERR_ALL_OK     - if SUCCESS.
 * @return -DA_ERR_BAD_HANDLE - bad handle
 * @return -DA_ERR_INT_ERR    - can't close open file descriptor
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
da_err_t DaDisableAccess(HANDLE handle)
{
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (close(dhptr->drvrFd)) {	/* close driver file handle */
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			perror("DaDisableAccess close()");
		return -DA_ERR_INT_ERR;
	}

	/* exclude from the list */
	list_del(&dhptr->hndl_list);

#ifdef __linux__
	if (dhptr->ma1 != MAP_FAILED)
		munmap(dhptr->ma1, dhptr->dit.addr1.range);
	if (dhptr->ma2 != MAP_FAILED)
		munmap(dhptr->ma2, dhptr->dit.addr2.range);
#endif
	/* close DMA handle */
	if (dhptr->dma.fd) close(dhptr->dma.fd);

	/* cleanup allocated memory */
	free(dhptr->reg_hash_tbl);
	free(dhptr->uh_vers_info_str);
	free(dhptr);

	return DA_ERR_ALL_OK;
}

/**
 * @brief Setup default register access method.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 * @param nam    -- new default access method
 *
 * In order to be able to switch between the methods -- they should be
 * requested during DaEnableAccess()
 *
 * @return  DA_ERR_ALL_OK     - new default access method is set
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad
 * @return -DA_ERR_BAD_AM     - access method is NOT allowed, i.e. it was not
 *                              requested during DaEnableAccess()
 *                              not possible to change an existing one.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
da_err_t DaSetDefAM(HANDLE handle, METHOD nam)
{
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(dhptr->reqAm & nam))
		/* was not requested during DaEnableAccess() */
		return -DA_ERR_BAD_AM;

	dhptr->defAm = nam;	/* switch to new Access Method */

	return DA_ERR_ALL_OK;
}

/**
 * @brief Get curren access method for the register accessing.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 *
 * @return Default access method (one of IOCTL, IOMMAP or IODMA)
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
METHOD DaGetDefAM(HANDLE handle)
{
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	return dhptr->defAm;
}

/**
 * @brief Get Driver/Simulator node open file descriptor for the given handle.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 *
 * User can use it to access driver directly.
 *
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
int DaGetNodeFd(HANDLE handle)
{
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	return dhptr->drvrFd;
}

/**
 * @brief Attemps to get value of the register @e rId.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess call
 * @param rId    -- register ID
 * @param buf    -- buffer to put data in
 * @param count  -- buffer size in bytes
 *
 * Each register consists of at @e LEAST one or more elements.
 * In case of one element - a register should be treated as @e normal one.
 * In case of several elements one can consider such a @e specific register
 * either as a set of the @e normal registers (i.e. each element is a register
 * itself) that are grouped together for convenience, or it can be just a chunk
 * of memory with several elements with a specified size. Number of register
 * elements and their size (which is identical in case of several elements!)
 * depends on the register definition itself, and can be obtained by means of
 * two functions:\n
 * 1. @e DaGetRegDepth() - get number of elements in the register.
 *                         Minimum one (1).\n
 * 2. @e DaGetRegSize()  - get element size.\n
 *
 * It's up to user to provide a buffer that is big enough to hold obtained
 * register values. Buffer size (in bytes) is passed in	@e count parameter.
 * Buffer should be big enough to store results.
 *
 * @return Number of obtained register elements is returned on SUCCESS.
 *         (Minimum '1').
 *
 * In case of error one of the following values:
 * @return -DA_ERR_B2S        - provided buffer is not big enough
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad
 * @return -DA_ERR_NO_REG     - no such register
 * @return -DA_ERR_INT_ERR    - can't get register value for some reason.
 *                              Information is printed out on the stderr
 *                              if DA_DBG_ERR_INFO debug flag is set.
 * @return -DA_ERR_NOT_ALLOW  - TODO
 * @return -DA_ERR_NOT_INIT   - lib was not init
 * @return -DA_ERR_BAD_AM     -- bad access method
 */
int DaGetRegister(HANDLE handle, int rId, void *buf, int count)
{
	long regDepth;		/* number of elements in register */
	long elOffs = 0;	/* offset of the first element to get */
	int OpId;
	int rv;			/* return value */
	REGDESC *rdP;
	METHOD curAm; /* current access method */
	int wOnly = FALSE;	/* write-only register */
	da_err_t dalerr;
	unsigned long arguments[3];	/* ioctl arguments */
	_dal_h *dhptr = dalGetHandle(handle);

	if (handle < 0) ;	/* TODO. Simulator */

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	curAm = dhptr->defAm;	/* set default access method */

	regDepth = (rdP->regDepth <= 0) ? 1 : rdP->regDepth;

	if ((regDepth * rdP->regSize) > count)
		return -DA_ERR_B2S;	/* user buffer is not big enough */

	if (rdP->regar == AMWR)	/* this is write-only register */
		wOnly = TRUE;

	/* Check and correct if needed, access mode. In case of Service
	   register only IOCTL access mode is possible */
	if (rdP->regType & RT_SRVS)
		curAm = IOCTL;

	/* check if read operation is possible for this register */
	if (wOnly && (rdP->regType & RT_SRVS)) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sRegister '%s' is write-only"
				" Service Register and cannot be read.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;	/* error */
	}
	if (wOnly && curAm == IOMMAP) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr,
				"DAL: %sRegister '%s' is write-only and cannot"
				" be read using IOMMAP access method."
				" Use IOCTL access method to get last"
				" history.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;	/* error */
	}

	/* all checkings are done, proceed */
	switch (curAm) {
	case IOCTL:
		dalGetIoctlId(rdP->rwIoctlOpNum, &OpId, NULL);
		arguments[0] = (unsigned long)buf; /* where to put
						      results */
		arguments[1] = regDepth; /* number of elements to read
					    1 in case of scalar register */
		arguments[2] = elOffs; /* element index. 0 in this case */
		rv = ioctl(dhptr->drvrFd, OpId, (char*)arguments);
		break;
	case IOMMAP: /* mmap access */
		{
			char *rba;	/* register base address */
			if (!strcmp(rdP->b_a, "addr1"))
				rba = dhptr->ma1;
			else
				rba = dhptr->ma2;
			rv = MMRegAccess(dhptr, rdP, OPRD, regDepth,
					 elOffs, rba, (char *)buf);
			break;
		}
	case IODMA:
		rv = do_dma(dhptr, rdP, OPRD, regDepth, elOffs, buf, count);
		break;
	default:
		return -DA_ERR_BAD_AM;
	}

	if (rv) {	/* can't get register */
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sCan't get '%s' Register.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;
	}

	if (!strcmp(rdP->busType, "PCI"))	/* TODO */
		LIBMatchEndian((char *)buf, rdP->regSize, regDepth);

	return regDepth; /* amount of obtained register elements */
}

/**
 * @brief Attempts to get a chunk of a so-called @b specific register @e rId.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess call
 * @param rId    -- register ID
 * @param elOffs -- offset of the first element to get (expressed in element
 *                  index!)
 * @param elN    -- number of elements to get (minimum 1)
 * @param buf    -- buffer to put data in
 * @param count  -- buffer size in bytes
 *
 * It's not an actual register, but rather a chunk of memory with the specified
 * ID, that consists of several elements with the @b SAME granularity
 * (byte, word, double word, etc...) So @b specific register can be considered
 * either as a set of the @b normal registers (i.e. each element is a register
 * itself) that are grouped together for convenience, or it can be just a chunk
 * of memory with several elements of the same size. Granularity and ID of such
 * memory chunks are set in the DataBase. Number of register elements and their
 * size (which is identical in case of several elements!) depends on the
 * register definition itself, and can be obtained by means of two functions:\n
 * 1. @e DaGetRegDepth() - get number of elements in the register.
 *                         Minimum one (1).\n
 * 2. @e DaGetRegSize()  - get size of each element.\n
 *
 * Function operates in terms of element offset inside the register, and
 * expects an offset of the first element to get in @e elOffs parameter.
 * Buffer @e buf should be big enough to hold obtained data of a specified
 * chunk. For example, if register is a set of integers and user wants to
 * get 5 elements, starting from the first element, then buffer @e buf size
 * @e count should be 5elements x 4bytes_each = 20 bytes long. And as offset
 * of the first element is zero, then @e elOffs	should be 0.
 *
 * @return Number of obtained register elements is returned on SUCCESS.
 *         (Minimum '1').
 *
 * On failure the return code is:
 * @return -DA_ERR_B2S        - provided buffer is not big enough.
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_INT_ERR    - can't get register value for some reason.
 *                              Information is printed out on the stderr
 *                              if DA_DBG_ERR_INFO debug flag is set.
 * @return -DA_ERR_NOT_ALLOW  - TODO
 * @return -DA_ERR_REG_BOUNDS - required elements are beyond register
 *                              bounds
 * @return -DA_ERR_NOT_INIT   - lib was not init
 * @return -DA_ERR_BAD_AM     -- bad access method
 */
int DaGetRegChunk(HANDLE handle, int rId, int elOffs, uint elN, void *buf,
		  int count)
{
	long regDepth;		/* number of elements in the register (min 1) */
	int OpId;
	int rv;			/* return value */
	REGDESC *rdP;
	METHOD curAm; /* current access method */
	int wOnly = FALSE;	/* write-only register */
	da_err_t dalerr;
	unsigned long arguments[3];	/* ioctl arguments */
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	curAm = dhptr->defAm;	/* set default access method */

	/* not applicable to service registers */
	if (rdP->regType & RT_SRVS) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sNo chunk reading for service"
				" registers.\n", ERR_MSG);
		return -DA_ERR_INT_ERR;	/* error */
	}

	/* get number of elements */
	regDepth = (rdP->regDepth <= 0) ? 1 : rdP->regDepth;

	/* check if number of requested elements is greater than zero,
	   if element offset and all requested elements are within register
	   range */
	if (!elN || (!WITHIN_RANGE(0, elOffs, regDepth - 1)) ||
	    ((elOffs + elN) > regDepth))
		return -DA_ERR_REG_BOUNDS;	/* error */

	/* check buffer size */
	if ((elN * rdP->regSize) > count)
		return -DA_ERR_B2S;	/* buffer is not big enough */

	if (rdP->regar == AMWR)	/* this is write-only register */
		wOnly = TRUE;

	/* check if read operation is possible for this register */
	if (wOnly && (rdP->regType & RT_SRVS)) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr,
				"DAL: %sRegister '%s' is write-only Service"
				" register and cannot be read.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;	/* error */
	}
	if (wOnly && curAm == IOMMAP) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr,
				"DAL: %sRegister '%s' is write-only and cannot"
				" be read using IOMMAP access method. Use"
				" IOCTL access method to get last history.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;	/* error */
	}

	/* all checkings are done, proceed */
	switch (curAm) {
	case IOCTL:
		dalGetIoctlId(rdP->rwIoctlOpNum, &OpId, NULL);
		arguments[0] = (unsigned long)buf; /* where to put
						      results */
		arguments[1] = elN; /* number of elements to read */
		arguments[2] = elOffs; /* element index */
		rv = ioctl(dhptr->drvrFd, OpId, (char*)arguments);
		break;
	case IOMMAP: /* mmap access */
		{
			char *rba;	/* register base address */
			if (!strcmp(rdP->b_a, "addr1"))
				rba = dhptr->ma1;
			else
				rba = dhptr->ma2;
			rv = MMRegAccess(dhptr, rdP, OPRD, elN,
						  elOffs, rba, (char *)buf);
			break;
		}
	case IODMA:
		rv = do_dma(dhptr, rdP, OPRD, elN, elOffs, buf, count);
		break;
	default:
		return -DA_ERR_BAD_AM;
	}

	if (rv) { /* can't get register */
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr,
				"DAL: %sCan't get '%s' Register chunk.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;
	}

	if (!strcmp(rdP->busType, "PCI"))	/* TODO */
		LIBMatchEndian((char *)buf, rdP->regSize, elN);

	return elN; /* amount of obtained register elements */
}

/**
 * @brief Attempts to set value of the register @e rId.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 * @param rId    -- register ID
 * @param buf    -- buffer that holds a value that should be assigne
 *                  to the register
 * @param bsz    -- buffer size in bytes
 *
 * Each register consists of at @b LEAST one or more elements. In case of one
 * element - a register should be treated as @b normal one. In case of several
 * elements one can consider such a @b specific register either as a set of the
 * @b normal registers (i.e. each element is a register itself) that are
 * grouped together for convenience, or it can be just a chunk of memory with
 * several elements with a specified size. Number of register elements and
 * their size (which is identical in case of several elements!) depends on the
 * register definition itself, and can be obtained by means of two functions:\n
 * 1. @e DaGetRegDepth() - get number of elements in the register.
 *                         Minimum one (1).\n
 * 2. @e DaGetRegSize()  - get element size.\n
 *
 * Function takes pointer to value that should be assign to register and retuns
 * number of elements that were assigned.
 *
 * @return Number of set register elements is returned on SUCCESS.
 *         (Minimum '1').
 *
 * On failure the return code is:
 * @return 0                 - shortcoming or overflow of provided data.
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_INT_ERR    - can't set register value for some reason.
 *                              Information is printed on stderr if
 *                              DA_DBG_ERR_INFO debug flag is set.
 * @return -DA_ERR_NOT_ALLOW  - register is not writeable.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 * @return -DA_ERR_BAD_AM     -- bad access method
 */
int DaSetRegister(HANDLE handle, int rId, void *buf, int bsz)
{
	long regDepth;		/* number of elements in register */
	long elOffs = 0;	/* offset of the first element to get */
	int OpId;
	int rv;			/* return value */
	REGDESC *rdP;
	METHOD curAm; /* current access method */
	da_err_t dalerr;
	unsigned long arguments[3];	/* ioctl arguments */
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	curAm = dhptr->defAm;	/* set default access method */
	regDepth = (rdP->regDepth <= 0) ? 1 : rdP->regDepth;

	/* safety check */
	if (bsz > regDepth * rdP->regSize) {
		fprintf(stderr, "DAL: %sData overflow.\n", ERR_MSG);
		return 0;
	} else if (bsz < regDepth * rdP->regSize) {
		fprintf(stderr, "DAL: %sData shortcoming.\n", ERR_MSG);
		return 0;
	}

	/* check if register operation is possible */
	if (!(rdP->regar & (AMEX | AMWR))) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr,
				"DAL: %sRegister '%s' cannot be written.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_NOT_ALLOW;	/* error */
	}

	/* Check and correct if needed, access mode. In case of Service
	   register only IOCTL access mode is possible */
	if (rdP->regType & RT_SRVS)
		curAm = IOCTL;

	/* all checkings are done, proceed */
	switch (curAm) {
	case IOCTL:
		dalGetIoctlId(rdP->rwIoctlOpNum, NULL, &OpId);
		arguments[0] = (unsigned long)buf; /* data address */
		arguments[1] = regDepth; /* number of elements to write
					    1 in case of scalar register */
		arguments[2] = elOffs; /* element index. 0 in this case */

		if (!strcmp(rdP->busType, "PCI"))	/* TODO */
			LIBMatchEndian((char *)buf, rdP->regSize,
				       regDepth);

		rv = ioctl(dhptr->drvrFd, OpId, (char *)arguments);
		break;
	case IOMMAP: /* mmap access */
		{
			char *rba;	/* register base address */
			if (!strcmp(rdP->b_a, "addr1"))
				rba = dhptr->ma1;
			else
				rba = dhptr->ma2;
			rv = MMRegAccess(dhptr, rdP, OPWR, regDepth,
					 elOffs, rba, (char *)buf);
			break;
		}
	case IODMA:
		rv = do_dma(dhptr, rdP, OPWR, regDepth, elOffs, buf, bsz);
		break;
	default:
		return -DA_ERR_BAD_AM;
	}

	if (rv) {	/* can't set register */
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sCan't set '%s' Register.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;
	}

	return regDepth; /* amount of set register elements */
}

/**
 * @brief Attempts to set a chunk of a so-called @b specific register @e rId.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 * @param rId    -- register ID
 * @param elOffs -- offset of the first element to set (expressed in element
 *                  index!)
 * @param elN    -- number of elements to set (minimum 1)
 * @param buf    -- buffer that holds a values that should be assigned to
 *                  the register chunk
 * @param count  -- buffer size in bytes
 *
 * It's not an actual register, but rather a chunk of memory with the specified
 * ID, that consists of several elements with the @b SAME granularity (byte,
 * word, double word, etc...). So @e specific register can be considered either
 * as a set of the @e normal registers (i.e. each element is a register itself)
 * that are grouped together for convenience, or it can be just a chunk of
 * memory with several elements of the same size. Granularity and ID of such
 * memory chunks are set in the @b DataBase. Number of register elements and
 * their size (which is identical in case of several elements!) depends on
 * the register definition itself, and can be obtained by means of two
 * functions:\n
 * 1. @e DaGetRegDepth() - get number of elements in the register.
 *                       Minimum one (1).\n
 * 2. @e DaGetRegSize()  - get size of each element in bytes.\n
 *
 * Function operates in terms of element offset inside the register, and
 * expects an offset of the first element to set in @e elOffs parameter.
 * Buffer @e buf should contain as many data as needed to set into a specified
 * memory chunk. For example, if register is a set of integers and user wants
 * to set 5 elements, starting from the first element, then buffer @e buf
 * should contain data to set and his size @e count should be
 * 5elements x 4bytes_each = 20 bytes long.  And as offset of the first element
 * is zero, then @e elOffs should be 0.
 *
 * @return Number of set register elements is returned on SUCCESS
 *         (Minimum '1').
 *
 * On failure the return code is:
 * @return 0                 - shortcoming or overflow of provided data
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_INT_ERR    - can't get register value for some reason
 *                              Information is printed out on the stderr
 *                              if DA_DBG_ERR_INFO flag is set.
 * @return -DA_ERR_NOT_ALLOW  - TODO
 * @return -DA_ERR_REG_BOUNDS - required elements are beyond register bounds
 * @return -DA_ERR_NOT_INIT   - lib was not init
 * @return -DA_ERR_BAD_AM     -- bad access method
 */
int DaSetRegChunk(HANDLE handle, int rId, int elOffs, uint elN, void *buf,
		  int count)
{
	long regDepth;		/* number of elements in register (min 1) */
	int OpId;
	int rv;			/* return value */
	REGDESC *rdP;
	METHOD curAm; /* current access method */
	da_err_t dalerr;
	unsigned long arguments[3];	/* ioctl arguments */
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	curAm = dhptr->defAm;	/* set default access method */

	/* not applicable to service registers */
	if (rdP->regType & RT_SRVS) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sNo chunk writing for service"
				" registers.\n", ERR_MSG);
		return -DA_ERR_INT_ERR;	/* error */
	}

	/* check if register operation is possible */
	if (!(rdP->regar & (AMEX | AMWR))) {
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr,
				"DAL: %sRegister '%s' cannot be written.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;	/* error */
	}

	/* get number of register elements */
	regDepth = (rdP->regDepth <= 0) ? 1 : rdP->regDepth;

	/* check if number of processed elements is greater than zero, if
	    element offset and all processed elements are within
	    register range */
	if (!elN || (!WITHIN_RANGE(0, elOffs, regDepth - 1))
	    || ((elOffs + elN) > regDepth))
		return -DA_ERR_REG_BOUNDS;	/* error */

	/* check data buffer */
	if (count > elN * rdP->regSize) {
		fprintf(stderr, "DAL: %sData overflow.\n", ERR_MSG);
		return 0;
	} else if (count < elN * rdP->regSize) {
		fprintf(stderr, "DAL: %sData shortcoming.\n", ERR_MSG);
		return 0;
	}

	/* all checkings are done, proceed */
	switch (curAm) {
	case IOCTL:
		/* get write ioctl number */
		dalGetIoctlId(rdP->rwIoctlOpNum, NULL, &OpId);
		arguments[0] = (unsigned long)buf; /* data address */
		arguments[1] = elN; /* number of elements to write */
		arguments[2] = elOffs; /* element index */

		if (!strcmp(rdP->busType, "PCI"))	/* TODO */
			LIBMatchEndian((char *)buf, rdP->regSize, elN);

		rv = ioctl(dhptr->drvrFd, OpId, (char *)arguments);
		break;
	case IOMMAP: /* mmap access */
		{
			char *rba;	/* register base address */
			if (!strcmp(rdP->b_a, "addr1"))
				rba = dhptr->ma1;
			else
				rba = dhptr->ma2;
			rv = MMRegAccess(dhptr, rdP, OPWR, elN,
						  elOffs, rba, (char *)buf);
			break;
		}
	case IODMA:
		rv = do_dma(dhptr, rdP, OPWR, elN, elOffs, buf, count);
		break;
	default:
		return -DA_ERR_BAD_AM;
	}

	if (rv) { /* can't set register */
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sCan't set '%s' Register"
				" chunk.\n", ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;
	}

	return elN; /* amount of set register elements */
}

/**
 * @brief Obtains number of elements in the register (i.e. register depth).
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 * @param rId    -- register ID
 *
 *  Register can consist of several elements, each of them have the same size.
 *
 * @return number of @b elements in the register. Minimum one.
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
int DaGetRegDepth(HANDLE handle, int rId)
{
	REGDESC *rdP;
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	return (rdP->regDepth <= 0) ? 1 : rdP->regDepth;
}

/**
 * @brief Obtains the size of a register element.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 * @param rId    -- register ID
 *
 * Each element have the same size. Register can consist of one or several
 * elements.
 *
 * @return Register element size in bytes.
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
int DaGetRegSize(HANDLE handle, int rId)
{
	REGDESC *rdP;
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	return rdP->regSize;
}

/**
 * @brief Read multiple times an element from a module register into a buffer
 *
 * @param hndl -- lib handle, returned by @e DaEnableAccess() call.
 * @param rId  -- register ID.
 * @param elOf -- offset of the element to get (expressed in element index!).
 * @param rcnt -- how many times register element should be read (min 1)
 * @param buf  -- user buffer to put data in
 * @param bsz  -- user buffer size in bytes
 *
 * Function performs multiple read on the given module register
 * (or one of the elements in the @e specific register) @b rId and put
 * obtained data in the user buffer @b buf.\n
 * In case of @e specific register (i.e. one that consists of several
 * elements) - only one register element can be read repeatedly by this
 * function. If you want to read multiple elements - this function should
 * be called several times for each of the element.\n
 * In case of a @e normal register (one that consist of one element) - @b elOf
 * should be zero, as there is only one element.\n
 * Only real module registers support repetitive r/w operations. I.e. function
 * is not working on @e extraneous registers @e service and <e>last history</e>
 * of write-only registers. Buffer @b buf should be big enough to hold data.
 *
 * @return how many times register was read - if success.
 *
 * In case of failure one of the following:
 * @return -DA_ERR_B2S        - provided buffer is not big enough
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_INT_ERR    - can't get register value for some reason
 *                              Information is printed out on the stderr
 *                              if DA_DBG_ERR_INFO flag is set.
 * @return -DA_ERR_NOT_INIT   - lib was not init.
 * @return -DA_ERR_NOT_ALLOW  - repetitive read is not allowed for this reg
 * @return -DA_ERR_REG_BOUNDS - required register element is beyond register
 *                              bounds or repetitive read counter is zero
 * @return -DA_ERR_BAD_AM     -- bad access method
 */
int DaGetRegRep(HANDLE hndl, int rId, int elOf, int rcnt, void *buf, int bsz)
{
	unsigned long arguments[4];	/* ioctl arguments */
	int OpId;
	long regDepth;		/* number of elements in register */
	int rv;			/* return value */
	REGDESC *rdP;
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(hndl);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	/* check if register operation is possible */
	if ((rdP->regType & (RT_SRVS | RT_EXTR)) || (rdP->regar == AMWR))
		return -DA_ERR_NOT_ALLOW;

	/* get number of register elements */
	regDepth = (rdP->regDepth <= 0) ? 1 : rdP->regDepth;

	/* check if repetitive write counter is greater than zero and
	   if element offset is within register range */
	if (!rcnt || (!WITHIN_RANGE(0, elOf, regDepth - 1)))
		return -DA_ERR_REG_BOUNDS;	/* error */

	if ((rcnt * rdP->regSize) > bsz)
		return -DA_ERR_B2S;	/* user buffer is not big enough */

	switch (dhptr->defAm) {
	case IOCTL:
		/* get write ioctl number */
		dalGetIoctlId(rdP->rwIoctlOpNum, NULL, &OpId);

		/* pack ioctl arguments */
		arguments[0] = OpId; /* ioctl number */
		arguments[1] = (unsigned long)buf;	/* data address */
		arguments[2] = rcnt;	/* repetitive read counter */
		arguments[3] = elOf;

		rv = ioctl(dhptr->drvrFd, SRV__REP_REG_RW,
				    (char*)arguments);
		break;
	case IOMMAP: /* mmap access */
		{
			char *rba;	/* register base address */
			if (!strcmp(rdP->b_a, "addr1"))
				rba = dhptr->ma1;
			else
				rba = dhptr->ma2;
			rv = MMRegAccess(dhptr, rdP, OPRDR, rcnt,
					 elOf, rba, (char *)buf);
			break;
		}
	case IODMA:
		rv = do_dma(dhptr, rdP, OPRDR, rcnt, elOf, buf, bsz);
		break;
	default:
		return -DA_ERR_BAD_AM;
	}

	if (rv) {	/* can't read register */
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sCan't do repetitive get"
				" on '%s' register.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;
	}

	return rcnt; /* how many times repetitive write was done */
}

/**
 * @brief Write multiple times user-defined value into a module register
 *
 * @param hndl -- lib handle, returned by @e DaEnableAccess() call.
 * @param rId  -- register ID.
 * @param elOf -- offset of the element to set (expressed in element index!).
 * @param wcnt -- how many times register element should be written (min 1)
 * @param buf  -- user buffer to get data from
 * @param bsz  -- user buffer size in bytes
 *
 * Function performs multiple write on the given module register
 * (or one of the elements in the @e specific register) @b rId.
 * Data to write is taken from the user buffer @b buf.\n
 * In case of @e specific register (i.e. one that consists of several
 * elements) - only one register element can be written repeatedly by this
 * function. If you want to write multiple elements - this function should
 * be called several times for each of the element.\n
 * In case of a @e normal register (one that consist of one element) - @b elOf
 * should be zero, as there is only one element.\n
 * Only real module registers support repetitive r/w operations. I.e. function
 * is not working on @e extraneous registers @e service and <e>last history</e>
 * of write-only registers. Buffer @e buf should contain as many data as needed
 * to be written into a specified register.\n
 * For example, if register is a set of words elements and user wants to write
 * ten (10) times into one of the register elements (i.e. @e wcnt
 * parameter = 10), then buffer @e buf should contain data to set and his
 * size @e bsz should be 10elements x 2bytes_each = 20 bytes.
 *
 * @return how many times register was written (Min 1) - if success.
 *
 * In case of failure one of the following:
 * @return 0                  - shortcoming or overflow of provided data.
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_INT_ERR    - can't set register value for some reason
 *                              Information is printed out on the stderr
 *                              if DA_DBG_ERR_INFO flag is set.
 * @return -DA_ERR_NOT_INIT   - lib was not init.
 * @return -DA_ERR_NOT_ALLOW  - repetitive write is not allowed for this reg
 * @return -DA_ERR_REG_BOUNDS - required register element is beyond register
 *                              bounds or repetitive write counter is zero
 * @return -DA_ERR_BAD_AM     -- bad access method
 */
int DaSetRegRep(HANDLE hndl, int rId, int elOf, int wcnt, void *buf, int bsz)
{
	unsigned long arguments[4];	/* ioctl arguments */
	int OpId;
	long regDepth;		/* number of elements in register */
	int rv;			/* return value */
	REGDESC *rdP;
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(hndl);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	/* check if register operation is possible */
	if ((rdP->regType & (RT_SRVS | RT_EXTR)) || (rdP->regar == AMRD))
		return -DA_ERR_NOT_ALLOW;

	/* get number of register elements */
	regDepth = (rdP->regDepth <= 0) ? 1 : rdP->regDepth;

	/* check if repetitive write counter is greater than zero and
	   if element offset is within register range */
	if (!wcnt || (!WITHIN_RANGE(0, elOf, regDepth - 1)))
		return -DA_ERR_REG_BOUNDS;	/* error */

	/* safety check */
	if (bsz > wcnt * rdP->regSize) {
		fprintf(stderr, "DAL: %sData overflow.\n", ERR_MSG);
		return 0;
	} else if (bsz < wcnt * rdP->regSize) {
		fprintf(stderr, "DAL: %sData shortcoming.\n", ERR_MSG);
		return 0;
	}

	switch (dhptr->defAm) {
	case IOCTL:
		/* get write ioctl number */
		dalGetIoctlId(rdP->rwIoctlOpNum, NULL, &OpId);

		/* pack ioctl arguments */
		arguments[0] = OpId;		   /* ioctl number */
		arguments[1] = (unsigned long)buf;	/* data address */
		arguments[2] = wcnt;	/* repetitive write counter */
		arguments[3] = elOf;

		rv = ioctl(dhptr->drvrFd, SRV__REP_REG_RW,
			   (char *)arguments);
		break;
	case IOMMAP: /* mmap access */
		{
			char *rba;	/* register base address */
			if (!strcmp(rdP->b_a, "addr1"))
				rba = dhptr->ma1;
			else
				rba = dhptr->ma2;
			rv = MMRegAccess(dhptr, rdP, OPWRR, wcnt,
					 elOf, rba, (char *)buf);
			break;
		}
	case IODMA:
		rv = do_dma(dhptr, rdP, OPWRR, wcnt, elOf, buf, bsz);
		break;
	default:
		return -DA_ERR_BAD_AM;
	}

	if (rv) { /* can't write register */
		if (dhptr->dal_flag & DA_DBG_ERR_INFO)
			fprintf(stderr, "DAL: %sCan't do repetitive set"
				" on '%s' register.\n",
				ERR_MSG, rdP->regName);
		return -DA_ERR_INT_ERR;
	}

	return wcnt; /* how many times repetitive write was done */

}

/**
 * @brief Gets register access mode (rwe).
 *
 * @param handle -- lib handle, returned by @e DaEnableAccess() call
 * @param rId    -- register ID
 *
 * Appropriate bits either set or not.  Use logical '&' to check if bits are
 * set or no. User should check if fit bits are set to find out the mode
 * (See ARIGHTS definition).
 *
 * @return Register access mode.
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
ARIGHTS DaGetRegAccessRights(HANDLE handle, int rId)
{
	REGDESC *rdP;
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return -DA_ERR_NO_REG;	/* no such register */

	return rdP->regar;
}

/**
 * @brief Obtains Register name by register ID.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call
 * @param rId    -- register ID
 *
 * User should copy retuned name to local buffer to prevent corruption by
 * subsequent calls.
 *
 * @return Register name.
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad.
 * @return -DA_ERR_NO_REG     - no such register.
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
char *DaGetRegName(HANDLE handle, int rId)
{
	REGDESC *rdP;
	static char tmp[MAX_STR];
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return (char *) dalerr;

	if (!(rdP = GET_REG_DESC(dhptr, rId)))
		return (char *) -DA_ERR_NO_REG;	/* no such register */

	strncpy(tmp, rdP->regName, sizeof(tmp));
	return tmp;
}

/**
 * @brief Driver/Simulator version information.
 *
 * @param handle        -- lib handle, ret. by @e DaEnableAccess() call
 * @param vers_str      -- if not NULL, then will be initialized to point to the
 *                         driver version information string
 * @param drvr_gen_date -- if not NULL, then driver generation date goes here
 *
 * @return current driver version (i.e. some positive value)
 * @return -DA_ERR_BAD_HANDLE - if user handle is bad
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
int DaDrvrVers(HANDLE handle, const char **vers_str, time_t * drvr_gen_date)
{
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (drvr_gen_date)
		*drvr_gen_date = dhptr->uh_dgd;

	if (vers_str)		/* check if user need it */
		*vers_str = dhptr->uh_vers_info_str;

	return dhptr->uh_drvr_vers;
}

/**
 * @brief Current DAL version information and library<->driver consistensy
 *        checking.
 *
 * @param hndl         -- If not 0 (zero), then user wants to check
 *                        driver<->library consistency. In this case it
 *                        @b SHOULD be lib handle, ret. by @e DaEnableAccess()
 *                        call. If zero - then no consistency cheking will be
 *                        done. Only library version and generation time will be
 *                        returned to the user.
 * @param vers_str     -- if not NULL, then will be initialized to point to the
 *                        current DAL version string.
 * @param lib_gen_date -- if not NULL, then DAL generation date goes here.
 *
 * If user doesn't want to check driver <-> library consistency - @e handle
 * should be zero.
 *
 * @return  DA_ERR_ALL_OK     - consistency checking was performed and
 *                              driver is up-to-date
 * @return -DA_ERR_INCOMPAT   - consistency checking was performed and
 *                              driver appears to be older than DAL.
 *                              Driver <b>MUST be re-generated!</b>
 * @return -DA_ERR_ERR        - consistency checking was not performed
 * @return -DA_ERR_BAD_HANDLE - provided handle is bad
 * @return -DA_ERR_NOT_INIT   - lib was not init
 */
int DaLibVers(HANDLE hndl, const char **vers_str, time_t * lib_gen_date)
{
	int cc = -DA_ERR_ERR;	/* consistency checking was not performed */
	da_err_t dalerr;
	_dal_h *dhptr;

	if (vers_str)
		*vers_str = g_dalvers;
	if (lib_gen_date)
		*lib_gen_date = DAL_GENERATION_TIME;

	if (hndl > 0) {
		/* user wants to check lib<->driver consistency */
		dhptr = dalGetHandle(hndl);

		if ((dalerr = ASSERT_USR_H(dhptr)))
			return dalerr;

		if (dhptr->uh_dgd < DAL_GENERATION_TIME)
			cc = -DA_ERR_INCOMPAT;	/* driver is older than DAL */
		else
			cc = DA_ERR_ALL_OK;	/* driver is up-to-date */
	}

	return cc;
}

/**
 * @brief Enable/disable/exploit current driver and DAL flags.
 *
 * @param handle -- lib handle, ret. by DaEnableAccess() call
 * @param flag   -- debug flags to toggle. In case of get - ignored
 * @param opt    -- get/set operation type: @b OPRD or @b OPWR
 *
 * If you want to get current debug flag value then third parameter @ref opt
 * should be @ref OPRD. The second parameter @ref flag is ignored in this case
 * and can be set to zero.
 * In case of @ref OPWR - you should indicate which flags you want to toggle.
 * So if the bit was on - it will be off after, and vice versa. In this case
 * previous debug flag value is returned.
 * Possible toggling flags are defined and can be found in @ref da_dbg type
 * for @b DAL and in @ref dbgIPL type for the driver.
 *
 * @return depends on the performed operation:
 *         1. If you want to set (i.e. write) new flag(s) - returns the
 *            previous value.
 *         2. If you want to get (i.e. read) current flags - returns
 *            current value of the debug flag.
 *
 * In case of failure one of the following:
 * @return -DA_ERR_BAD_HANDLE - user handle in bad
 * @return -DA_ERR_IOCTL_FAIL - can't get/set driver flags, because
 *                              ioctl fails.
 * @return -DA_ERR_INT_ERR    - user wants to toggle current flags,
 *                              but @e flag parameter is zero
 * @return -DA_ERR_NOT_INIT   - lib was not init
 * @return -DA_ERR_NOT_ALLOW  - requested operation is not allowed.
 */
int DaDbgFlag(HANDLE handle, int flag, REGOPTYPE opt)
{
	int old_dal_flg;	/* previous DAL flag */
	int drvr_flg;		/* driver flag */
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(handle);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (opt == OPRD) { /* -------- user just wants current flags ------- */
		if (ioctl(dhptr->drvrFd, SRV_GET_DEBUG_FLAG, (char *)&flag))
			return -DA_ERR_IOCTL_FAIL;
		else {
			flag |= dhptr->dal_flag; /* give current DAL flags
						    also */
			return flag;
		}
	} else if (opt == OPWR) { /* ----- user wants to set new flags ----- */
		if (!flag)
			return -DA_ERR_INT_ERR;

		old_dal_flg = dhptr->dal_flag;	/* save current */
		dhptr->dal_flag ^= (flag & DA_DBG_MASK); /* toggle DAL flags */
		flag &= DBGMASK;

		/* get current driver flags */
		if (ioctl(dhptr->drvrFd, SRV_GET_DEBUG_FLAG, (char *)&drvr_flg))
			return -DA_ERR_IOCTL_FAIL;

		if (flag) {
			/* perform SET ioctl only if some bits
			   should be toggeled */
			drvr_flg ^= flag;	/* toggle bits */
			/* set new flags in the driver. Previous value
			   will be returned */
			if (ioctl(dhptr->drvrFd, SRV_SET_DEBUG_FLAG,
				  (char*)&drvr_flg))
				return -DA_ERR_IOCTL_FAIL;
		}

		drvr_flg |= old_dal_flg;	/* give old DAL flags also */
		return drvr_flg;	/* return previous flag value */
	} else {
		return -DA_ERR_NOT_ALLOW;
	}
}

/**
 * @brief DAL error code decoder.
 *
 * @param dal_error -- error, returned by @b DAL function
 *
 * @return Pointer to structure, containing human error representation.
 */
da_err_str_t *DaGetErrCode(da_err_t dal_error)
{
	dal_error = abs(dal_error);

	if (dal_error > DA_ERR_LAST)	/* unknown error */
		dal_error = DA_ERR_LAST;

	return &dal_err_human[dal_error];
}

/**
 * @brief Enable/Disable/Query r/w bounds checking during register access
 *
 * @param hndl -- lib handle, returned by @e DaEnableAccess() call.
 * @param flg  -- 1 - to enable, 0 - to disable, 2 - to query current state
 *
 * @e NOTE. Valid _ONLY_ in case of Lynx!
 * In case of linux - checking is always done by the system.
 *
 * @return -DA_ERR_BAD_HANDLE - handle is bad
 * @return -DA_BAD_PARAM      - parameter is wrong
 * @return current state (1 - enabled, 0 - disabled)
 */
int DaRwBounds(HANDLE hndl, int flg)
{
	int rv;
	da_err_t dalerr;
	_dal_h *dhptr = dalGetHandle(hndl);

	if ((dalerr = ASSERT_USR_H(dhptr)))
		return dalerr;

	if (!WITHIN_RANGE(0, flg, 2))
		return -DA_BAD_PARAM;

	rv = ioctl(dhptr->drvrFd, SRV__RW_BOUNDS, &flg);
	return rv;
}


/**
 * @brief Mapping device memory into the user space for direct access
 *
 * @param fd   -- open driver node
 * @param dit  -- info table
 * @param lun  -- Logical Unit Number assigned to the module
 * @param map1 -- mapped address for space#1 goes here
 * @param map2 -- mapped address for space#2 goes here
 *
 * This functioin is OS-specific.
 *
 * @return  DA_ERR_ALL_OK  - if success
 * @return -DA_SYS_FAIL    - mmap failed (Linux only)
 * @return -DA_ERR_INT_ERR - IocModulPointer failed (Lynx only)
 */
static da_err_t map_device(int fd, DevInfo_t *dit, int lun,
			   char **map1, char **map2)
{
#ifdef __linux__
	int i;
	AddrInfo_t *aip = &dit->addr1;
	long _psz = sysconf(_SC_PAGESIZE);
	void *dd[ASA] = { [0 ... ASA-1] = MAP_FAILED };

	/* we should pass address space index (from 0 to ASA-1)
	   expressed in pagesizes to mmap */

#define ADDR_SPACE(x) (_psz*x)

	/* pass through all possible address spaces */
	for (i = 0; i < ASA; i++) {
		if (aip[i].baseAddr == ADCG__NO_ADDRESS)
			continue;
		dd[i] = mmap(0, aip[i].range, PROT_READ | PROT_WRITE,
			     MAP_SHARED, fd, ADDR_SPACE(i));
		if (dd[i] == MAP_FAILED) {
			perror("mmap()");
			goto outbad;
		}
	}
	*map1 = dd[0];
	*map2 = dd[1];
	return DA_ERR_ALL_OK;

 outbad:
	for (i = 0; i < ASA; i++)
		if (dd[i] != MAP_FAILED)
			munmap(dd[i], aip[i].range);
	return -DA_SYS_FAIL;

#else  /* __Lynx__ */
	IocModulPart mp;
	char *errMsg;
	int cc;

	/* address #1 */
	if (dit->addr1.baseAddr != ADCG__NO_ADDRESS) {
		mp = IOC_P1;
		cc = IocModulPointer(dit->mtn, lun, mp, map1);
		if (cc < 0) { /* ioconfiglib error */
			fprintf(stderr, "DAL: %sioconfig library call fails.\n",
				ERR_MSG);
			IocGetErrorMessage(cc, &errMsg);
			fprintf(stderr, "\t%s\n", errMsg);
			return -DA_ERR_INT_ERR;
		}
	}

	/* address #2 */
	if (dit->addr2.baseAddr != ADCG__NO_ADDRESS) {
		mp = IOC_P2;
		cc = IocModulPointer(dit->mtn, lun, mp, map2);
		if (cc < 0) { /* ioconfiglib error */
			fprintf(stderr, "DAL: %sioconfig library call fails.\n",
				ERR_MSG);
			IocGetErrorMessage(cc, &errMsg);
			fprintf(stderr, "\t%s\n", errMsg);
			return -DA_ERR_INT_ERR;
		}
	}
	return DA_ERR_ALL_OK;	/* 0 */
#endif
}

/**
 * @brief Construct full path file name of the driver.
 *
 * @param modName -- Module Name (exactly as in DataBase)
 * @param lun     -- Logical Unit Number assigned to the module.
 *                   Negative in case of driver simulator
 * @param chanN   -- Minor Device Number. There can be several entry points
 *                   for current Logical Unit Number.
 *
 * @return Absolute driver filename.
 */
static char *LIBBuildUpName(char *modName, int lun, int chanN)
{
	static char name[MAX_STR]; /* full file name path will be here */
	char *tmp = _ncf(modName);

	snprintf(name, sizeof(name), "/dev/" NODE_NAME_FMT,
		 tmp, (lun < 0) ? _SIML_ : _DRVR_, abs(lun), chanN);
	free(tmp);
	return name;
}

/**
 * @brief Create new @b DAL handle.
 *
 * Set handle ID and add it to the library handle list.
 *
 * @return pointer to newly created handle - if success.
 * @return NULL                            - if fails.
 */
static _dal_h *dalAddHandle(void)
{
	_dal_h *dhp = (_dal_h *) calloc(1, sizeof(*dhp)); /* new DAL handle */

	if (!dhp)
		return NULL;	/* can't allocate */

	INIT_LIST_HEAD(&dhp->hndl_list);

	list_add(&dhp->hndl_list /*new */ , &glob_dal_h_list /*head */ );
	dhp->hID = (long)&dhp->hID; /* handle ID is its address */
	return dhp;
}

/**
 * @brief Create register description hash table to speed-up register
 *        metadata searching.
 *
 * @param dhptr -- @b DAL handle pointer where hash table should be build.
 *
 * Table is build one-to-one correspondance, i.e. table index exactly maches
 * register ID.
 *
 * @return 0 - if success
 * @return 1 - otherwise
 */
static int dalDoRegHashTbl(_dal_h *dhptr)
{
	int cntr;

	dhptr->reg_hash_tbl = calloc(dhptr->dit.regAmount,
				     sizeof(*dhptr->reg_hash_tbl));
	if (!dhptr->reg_hash_tbl)
		return 1;	/* can't allocate */

	for (cntr = 0; cntr < dhptr->dit.regAmount; cntr++)
		dhptr->reg_hash_tbl[cntr] = &dhptr->dit.regDesc[cntr];

	return 0;		/* we cool */
}

/**
 * @brief Get read/write ioctl operation ID.
 *
 * @param opNum -- magic number to parse
 * @param Rop   -- read operation ID goes here
 * @param Wop   -- write operation ID goes here
 *
 * @return  0 - all OK.
 * @return -1 - if r/w ioctl number is not defined.
 */
static inline int dalGetIoctlId(int opNum, int *Rop, int *Wop)
{
	int oprd = 0, opwr = 0;

	/* extract read operation number  */
	if (Rop) {
		oprd = (opNum >> 16);
		if (oprd == -1) { /* error! read operation is not defined */
			*Rop = -1;
			return -1;
		}
		*Rop = (oprd + IOCTL_BASE);
	}

	/* extract write operation number */
	if (Wop) {
		opwr = opNum & 0x0000ffff;
		if (opwr == -1) { /* error! write operation is not defined */
			*Wop = -1;
			return -1;
		}
		*Wop = (opwr + IOCTL_BASE);
	}

	return 0;
}

/**
 * @brief Obtains lib handle from the linked list.
 *
 * @param handle -- lib handle, ret. by @e DaEnableAccess() call.
 *
 * @return handle pointer   - if found.
 * @return NULL             - if not found.
 * @return -DA_ERR_NOT_INIT - library was not initialized
 */
static inline _dal_h *dalGetHandle(HANDLE handle)
{
	_dal_h *dhp = (_dal_h *)container_of((void *)handle, struct _tagDALH,
					     hID);

	if (list_empty(&glob_dal_h_list))
		return (_dal_h *) -DA_ERR_NOT_INIT; /* library not init */

	if (dhp->hID != handle)
		return NULL;
	return dhp;
}

/**
 * @brief Converts data from Big Endian to Little Endian
 *
 * @param data      -- pointer to data that should be converted
 * @param typeSize  -- size of each element in bytes
 * @param dataDepth -- number of elements
 *
 * @return pointer to converted data.
 */
static char *LIBMatchEndian(char *data, int typeSize, int dataDepth)
{
	int i, j;
	int count;
	char *buffer = (char *)malloc(typeSize);

	if (dataDepth == 0)
		dataDepth++;

	for (j = 0; j < dataDepth; j++) {
		memcpy(buffer, data + (j * typeSize), typeSize);
		count = 0;
		for (i = typeSize - 1; i >= 0; i--)
			data[(j * typeSize) + count++] = buffer[i];
	}

	free(buffer);
	return data;
}

/**
 * @brief Printout device info table. Good for test purposes.
 *
 * @param ptr -- device info table
 *
 * @return void
 */
static void LIBPrintoutDevInfoT(DevInfo_t * ptr)
{
	int cntr;
	AddrInfo_t *aiptr = &(ptr->addr1);
	REGDESC *rdP = ptr->regDesc;

	for (cntr = 0; cntr < ASA; cntr++) {
		printf("Addr[%d].baseAddr  => 0x%lX\n", cntr, aiptr->baseAddr);
		printf("Addr[%d].range     => 0x%X\n", cntr, aiptr->range);
		printf("Addr[%d].increment => 0x%X\n", cntr, aiptr->increment);
		printf("Addr[%d].dpSize    => %d\n", cntr, aiptr->dpSize);
		printf("Addr[%d].addrModif => 0x%x\n", cntr, aiptr->addrModif);
		printf("------------------------------\n");
		aiptr++;
	}
	printf("=-=-=-=-=-=-=-=-=-=-=-=-=-=-\n");
	printf("'mtn' is %d\n", ptr->mtn);
	printf("'debugFlag' is 0x%X\n", ptr->debugFlag);
	printf("'opaque' is %s\n", ptr->opaque);
	printf("'iLevel' is %d\n", ptr->iLevel);
	printf("'iVector' is %d\n", ptr->iVector);
	printf("'iVectorInc' is %d\n", ptr->iVectorInc);
	printf("'chan' is %d\n", ptr->chan);
	printf("'chrindex' is %d\n", ptr->chrindex);
	printf("'regAmount' is %d\n", ptr->regAmount);
	printf("'maxRegSz' is %d\n", ptr->maxRegSz);
	printf("=-=-=-=-=-=-=-=-=-=-=-=-=-=-\n");
	for (cntr = 0; cntr < ptr->regAmount; cntr++) {
		printf("Reg[%d] 'ID' is %d\n", cntr, rdP[cntr].regId);
		printf("Reg[%d] 'regName' is %s\n", cntr, rdP[cntr].regName);
		printf("Reg[%d] 'busType' is %s\n", cntr, rdP[cntr].busType);
		printf("Reg[%d] 'regType' is %d\n", cntr, rdP[cntr].regType);
		printf("Reg[%d] 'regSize' is %d\n", cntr, rdP[cntr].regSize);
		printf("Reg[%d] 'b_a' is %s\n", cntr, rdP[cntr].b_a);
		printf("Reg[%d] 'regOffset' is 0x%X\n", cntr,
		       rdP[cntr].regOffset);
		printf("Reg[%d] 'regDepth' is %d\n", cntr, rdP[cntr].regDepth);
		printf("Reg[%d] 'regtl' is %d\n", cntr, rdP[cntr].regtl);
		printf("Reg[%d] 'regar' is %d\n", cntr, rdP[cntr].regar);
		printf("Reg[%d] 'rwIoctlOpNum' is 0x%x\n", cntr,
		       rdP[cntr].rwIoctlOpNum);
		printf("---------------------------------\n"
		       "---------------------------------\n");
	}
}

/**
 * @brief TODO. Interface is not yet defined.
 *
 * @param
 *
 * @return
 */
void DaUserEntryPoint()
{
}
